﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'The documentation can be found here:
'http://dlsc-software-consulting-gmbh.github.io/GMapsFX/apidocs/
'
Sub Class_Globals
	Private fx As JFX
	Private GMap As GoogleMap
	Private joGMap As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(GoogleMap1 As GoogleMap)
	GMap = GoogleMap1
	joGMap = GMap
End Sub

'Returns the title of a marker as string
Public Sub GetMarkerTitle(m As Marker) As String
	Dim jo As JavaObject = m
	jo = jo.RunMethod("getJSObject", Null)
	Dim propertyjs As String = $"this.getTitle();"$
	Return jo.RunMethod("eval", Array(propertyjs))
End Sub

'Returns the marker position as LatLng Object
Public Sub GetMarkerPosition(m As Marker) As LatLng
	Private joM As JavaObject = m
	Private PosLat As Double
	Private PosLng As Double
	'Get the javascript object from the marker and from that the position (using a javascript property as parameter) which is assigned to the javaobject
	joM = joM.RunMethod("getJSObject", Null)
	joM = joM.RunMethod("eval", Array($"this.getPosition();"$))
	PosLat = joM.RunMethod("eval", Array($"this.lat();"$))
	PosLng = joM.RunMethod("eval", Array($"this.lng();"$))
	'Init the LatLng object and assign the lat / lng
	Dim ll As LatLng
	ll.Initialize(PosLat,PosLng)
	Return ll
End Sub

Public Sub GetMarkerLabel( m As Marker)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	Private joL As JavaObject
	joL = joM.RunMethod("eval", Array($"this.getLabel();"$))
End Sub

Public Sub SetMarkerIcon( m As Marker, URL As String)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	joM.RunMethod("eval", Array($"this.setIcon({icon: "${URL}"});"$))
	Private joP As JavaObject
	joP.InitializeStatic("com.lynden.gmapsfx.javascript.object.GMapPoint")
'	joP.RunMethod("eval", Array($"this.x: 1, this.y: 1;"$))
End Sub

'Sets a MarkerLabel with the given values.
'Posible color values.
Public Sub SetMarkerLabel(m As Marker, Text As String, Color As String, TextSize As Double)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	joM.RunMethod("eval", Array($"this.setLabel({text: "${Text}", color: "${Color}", "fontSize": "${TextSize}px"});"$))
End Sub

'Removes the Marker Label for the given Marker
Public Sub RemoveMarkerLabel(m As Marker)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	Private propertyjs As String = $"this.setLabel(null);"$
	joM.RunMethod("eval", Array(propertyjs))
End Sub

'Sets the marker origin 'doesn't work!!!
Public Sub SetMarkerOrigin(m As Marker, X As Double, y As Double)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	Private joP As JavaObject
	joP.InitializeNewInstance("com.lynden.gmapsfx.javascript.object.GMapPoint", Array(X, y))
	Log(joP.RunMethod("eval", Array($"this.setIcon(
     {origin: "${joP}"
     });"$)))	
End Sub

'Sets the marker draggable property
Public Sub SetMarkerDraggable(m As Marker, Draggable As Boolean)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	If Draggable = True Then
		Private propertyjs As String = $"this.setDraggable(true);"$
	Else
		Private propertyjs As String = $"this.setDraggable(false);"$
	End If
	joM.RunMethod("eval", Array(propertyjs))
End Sub

'Sets the marker clickable property
Public Sub SetMarkerClickable(m As Marker, Clickable As Boolean)
	Private joM As JavaObject = m
	joM = joM.RunMethod("getJSObject", Null)
	If Clickable = True Then
		Private propertyjs As String = $"this.setClickable(true);"$
	Else
		Private propertyjs As String = $"this.setClickable(false);"$
	End If
	joM.RunMethod("eval", Array(propertyjs))
End Sub

'Sets the polygon clickable property 'doesn't work!!!
Public Sub SetPolygonClickable(pg As MapPolygon, Clickable As Boolean)
'	Private joP As JavaObject = p
'	joP = joP.RunMethod("getJSObject", Null)
'	Private joPO As JavaObject
'	joPO = joPO.RunMethod("getOptions", Null)
'	Private joPOJO As JavaObject
'	joPOJO = joPO.RunMethod("getJSObject", Null)
'	If Clickable = True Then
'		Private propertyjs As String = $"this.setClickable(true);"$
'	Else
'		Private propertyjs As String = $"this.setClickable(false);"$
'	End If
'	joPOJO.RunMethod("eval", Array(propertyjs))
	
	Private joM As JavaObject = pg
	joM = joM.RunMethod("getJSObject", Null)
	If Clickable = True Then
		joM.RunMethod("eval", Array($"this.setOprions({clickable: true);"$))
	Else
		joM.RunMethod("eval", Array($"this.setOprions({clickable: false);"$))
	End If
	
End Sub

'Returns the screen coordiantes for the given LatLng coordinates
Public Sub LatLonToXY(ll As LatLng) As Double()
	Private mapJO As JavaObject
	mapJO = joGMap.GetFieldJO("map")
	Private joProjection As JavaObject = mapJO.RunMethod("getProjection", Null)
	Private joBounds As JavaObject = mapJO.RunMethod("getBounds", Null)
	Private NE As LatLng = joBounds.RunMethod("getNorthEast", Null)
	Private SW As LatLng = joBounds.RunMethod("getSouthWest", Null)
	Private topRight As JavaObject = joProjection.RunMethod("fromLatLngToPoint", Array(NE))
	Private bottomLeft  As JavaObject = joProjection.RunMethod("fromLatLngToPoint", Array(SW))
	Private scale As Double = Power(2, GMap.CameraPosition.Zoom)
	Private worldPoint As JavaObject = joProjection.RunMethod("fromLatLngToPoint", Array(ll))
	Return Array As Double((worldPoint.RunMethod("getX", Null) - bottomLeft.RunMethod("getX", Null)) * scale, _
     (worldPoint.RunMethod("getY", Null) - topRight.RunMethod("getY", Null)) * scale)
End Sub

Public Sub LatLonToXY2(ll As LatLng) As Double()
	Dim mapJO As JavaObject
	mapJO = joGMap.GetFieldJO("map")
	Dim projection As JavaObject = mapJO.RunMethod("getProjection", Null)
	Dim bounds As JavaObject = mapJO.RunMethod("getBounds", Null)
	Dim ne As LatLng = bounds.RunMethod("getNorthEast", Null)
	Dim sw As LatLng = bounds.RunMethod("getSouthWest", Null)
	Dim topRight As JavaObject = projection.RunMethod("fromLatLngToPoint", Array(ne))
	Dim bottomLeft  As JavaObject = projection.RunMethod("fromLatLngToPoint", Array(sw))
	Dim scale As Double = Power(2, GMap.CameraPosition.Zoom)
	Dim worldPoint As JavaObject = projection.RunMethod("fromLatLngToPoint", Array(ll))
   
	Dim PointX, PointY As Double
	Dim EastB As Double = ne.Longitude
	Dim WestB As Double = sw.Longitude
	Dim MarkerLng As Double = ll.Longitude
	Dim ScreenDegrees As Double
	Dim DegPerPix As Double

	' Get X&Y by getProjection
	PointX = (worldPoint.RunMethod("getX", Null) - bottomLeft.RunMethod("getX", Null)) * scale
	PointY = (worldPoint.RunMethod("getY", Null) - topRight.RunMethod("getY", Null)) * scale
   
	' Get X 180Long when is included in map.
	'Screen width is measured in both pixels and degrees, MarkerLng is known in degrees, calculated in pixels = X.
	If WestB > EastB Then
		ScreenDegrees = (180-WestB) + (180+EastB)
		'        DegPerPix = ScreenDegrees/Pane1.Width
		If MarkerLng > 0 Then PointX = (MarkerLng - WestB) / DegPerPix
		If MarkerLng < 0 Then PointX = ((180+MarkerLng) + (180-WestB))/DegPerPix
	End If
	Return Array As Double(PointX, PointY)
End Sub

'Returns the Lat/Lng coordinates for the given screen coordinates  'doesn't work!!!
Public Sub XYToLatLng(x As Double, y As Double) As LatLng
	Private ll As LatLng
	Dim mapJO As JavaObject
	mapJO = joGMap.GetFieldJO("map")
	Private joProjection As JavaObject = mapJO.RunMethod("getProjection", Null)
	Private joBounds As JavaObject = mapJO.RunMethod("getBounds", Null)
	Private NE As LatLng = joBounds.RunMethod("getNorthEast", Null)
	Private SW As LatLng = joBounds.RunMethod("getSouthWest", Null)
	Private topRight As JavaObject = joProjection.RunMethod("fromLatLngToPoint", Array(NE))
	Private bottomLeft  As JavaObject = joProjection.RunMethod("fromLatLngToPoint", Array(SW))
	Private Scale As Double = Power(2, GMap.CameraPosition.Zoom)

	Private xy(2) As Double
	xy(0) = x / Scale + bottomLeft.RunMethod("getX", Null)
	xy(1) = y / Scale + topRight.RunMethod("getY", Null)
	Private joProjectionJS As JavaObject = joProjection.RunMethod("getJSObject", Null)
	Private joPoint As JavaObject
'	joPoint.InitializeNewInstance("com.lynden.gmapsfx.javascript.object.GMapPoint", Array (x / Scale + bottomLeft.RunMethod("getX", Null), y / Scale + topRight.RunMethod("getY", Null)))
	joPoint.InitializeNewInstance("javafx.geometry.Point2D", Array (x / Scale + bottomLeft.RunMethod("getX", Null), y / Scale + topRight.RunMethod("getY", Null)))
'	ll = joProjectionJS.RunMethod("eval", Array($"this.fromPointToLatLng({joPoint})"$))
	Private jo As JavaObject = mapJO.RunMethod("getJSObject", Null)
'	ll = jo.RunMethod("eval", Array($"this.fromPointToLatLng({joPoint})"$))
'	ll = joProjectionJS.RunMethod("eval", Array($"this.fromPointToLatLng({xy})"$))
	Return ll
End Sub

'Returns the distance between two points in meters
Public Sub GetDistance(Point1 As LatLng, Point2 As LatLng) As Double
	Private jo As JavaObject
	
	jo.InitializeNewInstance("com.lynden.gmapsfx.javascript.object.LatLong", Array (Point1.Latitude, Point1.Longitude))
	Return jo.RunMethod("distanceFrom", Array (Point2))
End Sub

'Returns the bearing between two points, from point1 to point2
Public Sub GetBearing(Point1 As LatLng, Point2 As LatLng) As Double
	Private jo As JavaObject
	
	jo.InitializeNewInstance("com.lynden.gmapsfx.javascript.object.LatLong", Array (Point1.Latitude, Point1.Longitude))
	Return jo.RunMethod("getBearing", Array (Point2))
End Sub

'Sets a polygon or polyline to geodesic points
Public Sub SetGeodesic(shape As JavaObject)
	shape.GetFieldJO("jsObject").RunMethod("eval", Array($"
       this.setOptions({
          geodesic: true
        });
   "$))
End Sub